Package org.eclipse.cdt.core.dom.ast

# Enum Class IASTExpression.ValueCategory

java.lang.Object
java.lang.Enum<IASTExpression.ValueCategory>
org.eclipse.cdt.core.dom.ast.IASTExpression.ValueCategory

All Implemented Interfaces:
  `Serializable`, `Comparable<IASTExpression.ValueCategory>`, `java.lang.constant.Constable`

Enclosing interface:
  `IASTExpression`

public static enum IASTExpression.ValueCategory extends Enum<IASTExpression.ValueCategory>

Since:
  5.3

## Nested Class Summary

## Nested classes/interfaces inherited from class java.lang.Enum

`Enum.EnumDesc<E extends Enum<E>>`

## Enum Constant Summary

Enum Constants
Enum Constant
Description
`LVALUE`
Traditional lvalue
`PRVALUE`
Pure rvalue.
`XVALUE`
Expiring value as introduced by c++11.

## Method Summary

Modifier and Type
Method
Description
`boolean`
`isGLValue()`
A generalized lvalue is either an lvalue or an xvalue.
`boolean`
`isRValue()`
Both prvalues and xvalues are rvalues.
`static IASTExpression.ValueCategory`
`valueOf(String name)`
Returns the enum constant of this class with the specified name.
`static IASTExpression.ValueCategory[]`
`values()`
Returns an array containing the constants of this enum class, in the order they are declared.

### Methods inherited from class java.lang.Enum

`clone, compareTo, describeConstable, equals, finalize, getDeclaringClass, hashCode, name, ordinal, toString, valueOf`

### Methods inherited from class java.lang.Object

`getClass, notify, notifyAll, wait, wait, wait`

## Enum Constant Details

### LVALUE

public static final IASTExpression.ValueCategory LVALUE
Traditional lvalue

### XVALUE

public static final IASTExpression.ValueCategory XVALUE
Expiring value as introduced by c++11.

### PRVALUE

public static final IASTExpression.ValueCategory PRVALUE
Pure rvalue.

## Method Details

### values

public static IASTExpression.ValueCategory[] values()
Returns an array containing the constants of this enum class, in the order they are declared.

Returns:
  an array containing the constants of this enum class, in the order they are declared

### valueOf

public static IASTExpression.ValueCategory valueOf(String name)
Returns the enum constant of this class with the specified name. The string must match exactly an identifier used to declare an enum constant in this class. (Extraneous whitespace characters are not permitted.)

Parameters:
  `name` - the name of the enum constant to be returned.
Returns:
  the enum constant with the specified name
Throws:
  `IllegalArgumentException` - if this enum class has no constant with the specified name
  `NullPointerException` - if the argument is null

### isRValue

public boolean isRValue()
Both prvalues and xvalues are rvalues.

### isGLValue

public boolean isGLValue()
A generalized lvalue is either an lvalue or an xvalue.